]> git.sesse.net Git - ffmpeg/blob - tests/fate-run.sh
sws/output: fix ordered dither threshold for mono output
[ffmpeg] / tests / fate-run.sh
1 #! /bin/sh
2
3 export LC_ALL=C
4
5 base=$(dirname $0)
6 . "${base}/md5.sh"
7
8 base64=tests/base64
9
10 test="${1#fate-}"
11 target_samples=$2
12 target_exec=$3
13 target_path=$4
14 command=$5
15 cmp=${6:-diff}
16 ref=${7:-"${base}/ref/fate/${test}"}
17 fuzz=${8:-1}
18 threads=${9:-1}
19 thread_type=${10:-frame+slice}
20 cpuflags=${11:-all}
21 cmp_shift=${12:-0}
22 cmp_target=${13:-0}
23 size_tolerance=${14:-0}
24 cmp_unit=${15:-2}
25 gen=${16:-no}
26 hwaccel=${17:-none}
27
28 outdir="tests/data/fate"
29 outfile="${outdir}/${test}"
30 errfile="${outdir}/${test}.err"
31 cmpfile="${outdir}/${test}.diff"
32 repfile="${outdir}/${test}.rep"
33
34 target_path(){
35     test ${1} = ${1#/} && p=${target_path}/
36     echo ${p}${1}
37 }
38
39 # $1=value1, $2=value2, $3=threshold
40 # prints 0 if absolute difference between value1 and value2 is <= threshold
41 compare(){
42     awk "BEGIN { v = $1 - $2; printf ((v < 0 ? -v : v) > $3) }"
43 }
44
45 do_tiny_psnr(){
46     psnr=$(tests/tiny_psnr "$1" "$2" $cmp_unit $cmp_shift 0) || return 1
47     val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
48     size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
49     size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
50     val_cmp=$(compare $val $cmp_target $fuzz)
51     size_cmp=$(compare $size1 $size2 $size_tolerance)
52     if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
53         echo "$psnr"
54         if [ "$val_cmp" != 0 ]; then
55             echo "$3: |$val - $cmp_target| >= $fuzz"
56         fi
57         if [ "$size_cmp" != 0 ]; then
58             echo "size: |$size1 - $size2| >= $size_tolerance"
59         fi
60         return 1
61     fi
62 }
63
64 oneoff(){
65     do_tiny_psnr "$1" "$2" MAXDIFF
66 }
67
68 stddev(){
69     do_tiny_psnr "$1" "$2" stddev
70 }
71
72 oneline(){
73     printf '%s\n' "$1" | diff -u -b - "$2"
74 }
75
76 run(){
77     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
78     $target_exec $target_path/"$@"
79 }
80
81 runecho(){
82     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
83     $target_exec $target_path/"$@" >&3
84 }
85
86 probefmt(){
87     run ffprobe${PROGSUF} -show_entries format=format_name -print_format default=nw=1:nk=1 -v 0 "$@"
88 }
89
90 runlocal(){
91     test "${V:-0}" -gt 0 && echo ${base}/"$@" ${base} >&3
92     ${base}/"$@" ${base}
93 }
94
95 probeframes(){
96     run ffprobe${PROGSUF} -show_frames -v 0 "$@"
97 }
98
99 ffmpeg(){
100     dec_opts="-hwaccel $hwaccel -threads $threads -thread_type $thread_type"
101     ffmpeg_args="-nostdin -nostats -cpuflags $cpuflags"
102     for arg in $@; do
103         [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
104         ffmpeg_args="${ffmpeg_args} ${arg}"
105     done
106     run ffmpeg${PROGSUF} ${ffmpeg_args}
107 }
108
109 framecrc(){
110     ffmpeg "$@" -flags +bitexact -fflags +bitexact -f framecrc -
111 }
112
113 framemd5(){
114     ffmpeg "$@" -flags +bitexact -fflags +bitexact -f framemd5 -
115 }
116
117 crc(){
118     ffmpeg "$@" -f crc -
119 }
120
121 md5(){
122     ffmpeg "$@" md5:
123 }
124
125 pcm(){
126     ffmpeg "$@" -vn -f s16le -
127 }
128
129 fmtstdout(){
130     fmt=$1
131     shift 1
132     ffmpeg -flags +bitexact -fflags +bitexact "$@" -f $fmt -
133 }
134
135 enc_dec_pcm(){
136     out_fmt=$1
137     dec_fmt=$2
138     pcm_fmt=$3
139     src_file=$(target_path $4)
140     shift 4
141     encfile="${outdir}/${test}.${out_fmt}"
142     cleanfiles=$encfile
143     encfile=$(target_path ${encfile})
144     ffmpeg -i $src_file "$@" -f $out_fmt -y ${encfile} || return
145     ffmpeg -flags +bitexact -fflags +bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -fflags +bitexact -f ${dec_fmt} -
146 }
147
148 FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
149 DEC_OPTS="-threads $threads -idct simple $FLAGS"
150 ENC_OPTS="-threads 1        -idct simple -dct fastint"
151
152 enc_dec(){
153     src_fmt=$1
154     srcfile=$2
155     enc_fmt=$3
156     enc_opt=$4
157     dec_fmt=$5
158     dec_opt=$6
159     encfile="${outdir}/${test}.${enc_fmt}"
160     decfile="${outdir}/${test}.out.${dec_fmt}"
161     cleanfiles="$cleanfiles $decfile"
162     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
163     tsrcfile=$(target_path $srcfile)
164     tencfile=$(target_path $encfile)
165     tdecfile=$(target_path $decfile)
166     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
167         -f $enc_fmt -y $tencfile || return
168     do_md5sum $encfile
169     echo $(wc -c $encfile)
170     ffmpeg $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
171         -f $dec_fmt -y $tdecfile || return
172     do_md5sum $decfile
173     tests/tiny_psnr $srcfile $decfile $cmp_unit $cmp_shift
174 }
175
176 lavffatetest(){
177     t="${test#lavf-fate-}"
178     ref=${base}/ref/lavf-fate/$t
179     ${base}/lavf-regression.sh $t lavf-fate tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
180 }
181
182 lavftest(){
183     t="${test#lavf-}"
184     ref=${base}/ref/lavf/$t
185     ${base}/lavf-regression.sh $t lavf tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
186 }
187
188 video_filter(){
189     filters=$1
190     shift
191     label=${test#filter-}
192     raw_src="${target_path}/tests/vsynth1/%02d.pgm"
193     printf '%-20s' $label
194     ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
195         $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo -frames:v 5 $* -f nut md5:
196 }
197
198 pixfmts(){
199     filter=${test#filter-pixfmts-}
200     filter=${filter%_*}
201     filter_args=$1
202     prefilter_chain=$2
203     nframes=${3:-1}
204
205     showfiltfmts="$target_exec $target_path/libavfilter/filtfmts-test"
206     scale_exclude_fmts=${outfile}_scale_exclude_fmts
207     scale_in_fmts=${outfile}_scale_in_fmts
208     scale_out_fmts=${outfile}_scale_out_fmts
209     in_fmts=${outfile}_in_fmts
210
211     # exclude pixel formats which are not supported as input
212     $showfiltfmts scale | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_in_fmts
213     $showfiltfmts scale | awk -F '[ \r]' '/^OUTPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_out_fmts
214     comm -12 $scale_in_fmts $scale_out_fmts >$scale_exclude_fmts
215
216     $showfiltfmts $filter | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$in_fmts
217     pix_fmts=$(comm -12 $scale_exclude_fmts $in_fmts)
218
219     outertest=$test
220     for pix_fmt in $pix_fmts; do
221         test=$pix_fmt
222         video_filter "${prefilter_chain}format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt -frames:v $nframes
223     done
224
225     rm $in_fmts $scale_in_fmts $scale_out_fmts $scale_exclude_fmts
226     test=$outertest
227 }
228
229 gapless(){
230     sample=$(target_path $1)
231     extra_args=$2
232
233     decfile1="${outdir}/${test}.out-1"
234     decfile2="${outdir}/${test}.out-2"
235     decfile3="${outdir}/${test}.out-3"
236     cleanfiles="$cleanfiles $decfile1 $decfile2 $decfile3"
237
238     # test packet data
239     ffmpeg $extra_args -i "$sample" -flags +bitexact -fflags +bitexact -c:a copy -f framecrc -y $decfile1
240     do_md5sum $decfile1
241     # test decoded (and cut) data
242     ffmpeg $extra_args -i "$sample" -flags +bitexact -fflags +bitexact -f wav md5:
243     # the same as above again, with seeking to the start
244     ffmpeg $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -flags +bitexact -fflags +bitexact -c:a copy -f framecrc -y $decfile2
245     do_md5sum $decfile2
246     ffmpeg $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -flags +bitexact -fflags +bitexact -f wav md5:
247     # test packet data, with seeking to a specific position
248     ffmpeg $extra_args -ss 5 -seek_timestamp 1 -i "$sample" -flags +bitexact -fflags +bitexact -c:a copy -f framecrc -y $decfile3
249     do_md5sum $decfile3
250 }
251
252 concat(){
253     template=$1
254     sample=$2
255     mode=$3
256     extra_args=$4
257
258     concatfile="${outdir}/${test}.ffconcat"
259     packetfile="${outdir}/${test}.ffprobe"
260     cleanfiles="$concatfile $packetfile"
261
262     awk "{gsub(/%SRCFILE%/, \"$sample\"); print}" $template > $concatfile
263
264     if [ "$mode" = "md5" ]; then
265         run ffprobe${PROGSUF} -bitexact -show_streams -show_packets -v 0 -fflags keepside -safe 0 $extra_args $concatfile | tr -d '\r' > $packetfile
266         do_md5sum $packetfile
267     else
268         run ffprobe${PROGSUF} -bitexact -show_streams -show_packets -v 0 -of compact=p=0:nk=1 -fflags keepside -safe 0 $extra_args $concatfile
269     fi
270 }
271
272 mkdir -p "$outdir"
273
274 # Disable globbing: command arguments may contain globbing characters and
275 # must be kept verbatim
276 set -f
277
278 exec 3>&2
279 eval $command >"$outfile" 2>$errfile
280 err=$?
281
282 if [ $err -gt 128 ]; then
283     sig=$(kill -l $err 2>/dev/null)
284     test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
285 fi
286
287 if test -e "$ref" || test $cmp = "oneline" ; then
288     case $cmp in
289         diff)   diff -u -b "$ref" "$outfile"            >$cmpfile ;;
290         rawdiff)diff -u    "$ref" "$outfile"            >$cmpfile ;;
291         oneoff) oneoff     "$ref" "$outfile"            >$cmpfile ;;
292         stddev) stddev     "$ref" "$outfile"            >$cmpfile ;;
293         oneline)oneline    "$ref" "$outfile"            >$cmpfile ;;
294         null)   cat               "$outfile"            >$cmpfile ;;
295     esac
296     cmperr=$?
297     test $err = 0 && err=$cmperr
298     test $err = 0 || cat $cmpfile
299 else
300     echo "reference file '$ref' not found"
301     err=1
302 fi
303
304 if [ $err -eq 0 ]; then
305     unset cmpo erro
306 else
307     cmpo="$($base64 <$cmpfile)"
308     erro="$($base64 <$errfile)"
309 fi
310 echo "${test}:${sig:-$err}:$cmpo:$erro" >$repfile
311
312 if test $err != 0 && test $gen != "no" ; then
313     echo "GEN     $ref"
314     cp -f "$outfile" "$ref"
315     err=$?
316 fi
317
318 if test $err = 0; then
319     rm -f $outfile $errfile $cmpfile $cleanfiles
320 elif test $gen = "no"; then
321     echo "Test $test failed. Look at $errfile for details."
322     test "${V:-0}" -gt 0 && cat $errfile
323 else
324     echo "Updating reference failed, possibly no output file was generated."
325 fi
326 exit $err